#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,m,c;
    scanf("%d",&n);
    scanf("%d",&m);
    int b[m+1];
    int a[n+1];
    for(int i=1;i<=n;i++)
        a[i]=i;
    for(int i=1;i<=m;i++)
        scanf("%d",&b[i]);
    scanf("%d",&c);

    long long stepC[n+1];
    stepC[0]=1;
    for(int i=1;i<n+1;i++)
        stepC[i]=stepC[i-1]*c;

    for(int i=0;i<=n-m;i++)
    {
        for(int j=1;j<=m;j++)
            a[i+b[j]]=a[i+j];
    }
    
    long long rez=0;
    for(int i=1;i<=n;i++)
    {
        rez+=stepC[i]*a[i];
    }

    cout<<rez%998244353;
    return 0;
}